/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: cdd_redund_client.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <polymake.h>
#include <Rational.h>
#define GMPRATIONAL
#include <cdd_interface.h>

namespace polymake { namespace polytope {

void cdd_eliminate_redundant_points(perl::Object p)
{
   cdd_interface::solver<Rational> solver;
   const Matrix<Rational> P=p.give("POINTS");
   const cdd_interface::solver<Rational>::non_redundant non_red=solver.find_vertices_among_points(P);
   p.take("VERTICES") << P.minor(non_red.first,All);
   p.take("VERTEX_NORMALS") << non_red.second;
}

void cdd_vertex_normals(perl::Object p)
{
   cdd_interface::solver<Rational> solver;
   const Matrix<Rational> P=p.give("VERTICES");
   const cdd_interface::solver<Rational>::non_redundant non_red=solver.find_vertices_among_points(P);
   p.take("VERTEX_NORMALS") << non_red.second;
}

Function4perl(&cdd_eliminate_redundant_points, "cdd_eliminate_redundant_points(Polytope<Rational>)");
Function4perl(&cdd_vertex_normals, "cdd_vertex_normals(Polytope<Rational>)");

} }
